<i18n>
{
  "fr": {
    "title": "Déplacements domicile / travail",
    "save-msg-1": "Le message d'en-tête du questionnaire a été mis à jour avec <strong><span style='color:green;'>succès</span></strong>.",
    "save-msg-2": "Les informations de déplacements domicile / travail ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "warning-msg-1": "Le nombre d'ITA répondant au questionnaire est supérieur au nombre d'ITA déclaré dans le laboratoire.",
    "warning-msg-2": "Le nombre de Docs. / post-docs. répondant au questionnaire est supérieur au nombre de Docs. / post-docs. déclaré dans le laboratoire.",
    "warning-msg-3": "Le nombre de Chercheurs / Enseignants-ch. répondant au questionnaire est supérieur au nombre de Chercheurs / Enseignants-ch. déclaré dans le laboratoire.",
    "error-msg-1": "Suppression",
    "error-msg-2": "Êtes vous sûr de vouloir supprimer l'ensemble des déplacements domicile / travail?",
    "error-msg-3": "L'enquête 2020 n'est pas clonable",
    "error-msg-4": "L'année 2020 étant atypique, son enquête doit être réalisée",
    "error-msg-5": "Des réponses à l'enquête sont déjà enregistrées, le clonage est impossible",
    "error-msg-6": "L'enquête du BGES",
    "error-msg-7": "est déjà une enquête clonée",
    "error-msg-8": "Aucun BGES disponible en",
    "validate-msg-1": "Validation",
    "validate-msg-2": "Des déplacement aberrants ont été détectés dans vos données. <br /> Êtes vous sûr de vouloir valider sans les supprimer?",
    "info-1": "Les émissions des déplacements domicile / travail sont évaluées à l'aide d'un formulaire configuré spécifiquement pour votre laboratoire. Vous pouvez : <ul style='list-style-type:square;margin-left:25px'><li>soit envoyer le questionnaire à vos collègues en copiant-collant l'adresse ci-dessous et en cliquant sur le bouton <strong>«Activer»</strong>. Lorsque vous décidez de clore définitivement le questionnaire, cliquez sur le bouton <strong>«Désactiver»</strong>.</li><li>soit cloner les réponses du questionnaire de l’année précédente et calculer les émissions de GES sur la base de l’effectif de l’année en cours. Seul le questionnaire de l’année précédente peut être cloné, sauf celui de 2020 à cause des confinements qui ont pu modifier durablement les modes de déplacement du personnel.</li></ul>",
    "info-3": "Afin d’obtenir un taux de réponse élevé, il est important que le questionnaire soit envoyé hors vacances scolaires et hors période estivale. Il est recommandé de l’envoyer une première fois en début de matinée au début d’une semaine, puis de faire une relance en début de matinée au début de la semaine suivante, en indiquant alors la date limite de réponse. Une dernière relance peut être effectuée en début de matinée du jour de la clôture de l’enquête.",
    "info-4": "Lors de l'envoi par email du questionnaire à vos collègues, insistez sur le fait que vos collègues ne doivent répondre qu'une seule fois au questionnaire. En effet, le questionnaire étant anonyme,  il ne serait pas possible d'identifier d'éventuels doublons.",
    "info-5": "Les émissions des déplacements domicile / travail sont évaluées à l'aide d'un formulaire nécessitant d'envoyer un lien à vos collègues. Celui-ci étant spécifique à un BGES, il nécessite une connexion à une base de données et est donc indisponible dans la version non authentifiée de <em>GES 1point5</em>.",
    "info-6": "Vous pouvez cependant ajouter et modifier des déplacements domicile / travail directement avec l'interface.",
    "info-7": "Pour le <strong>calcul des émissions de 2020</strong>, l’année comprend <strong>27 semaines</strong> de déplacements (41 semaines travaillées – 14 semaines de confinement) : l’hypothèse simplificatrice est que, pendant les confinements, aucun agent n’a eu d’astreinte sur site et qu’aucun agent n’a pris de congés.",
    "info-8": "Pour le <strong>calcul des émissions de 2021</strong>, l’année comprend <strong>37 semaines</strong> de déplacements (41 semaines travaillées – 4 semaines de confinement) : l’hypothèse simplificatrice est faite que pendant le 3ème confinement, aucun agent n’a eu d’astreinte sur site et qu’aucun agent n’a pris de congés.",
    "info-9": "Les",
    "info-10": "réponses extrêmes",
    "info-11": "présentées en rouge sont détectées à partir des distances journalières parcourues par individu tous modes de déplacement confondus. Merci d'inspecter les réponses de l'enquête.",
    "info-12": "Les réponses extrêmes sont ici définies comme étant toute valeur située à l'extérieur de l'intervalle <em>[q1-3x(q3-q1) ; q3+3x(q3-q1)]</em>, où <em>q1</em> et <em>q3</em> sont le premier et troisième quartiles et <em>(q3-q1)</em> l'intervalle interquartile.",
    "info-13": "Aucune réponse extrême n'a été détectée. Cependant, <strong>au moins une valeur tire la moyenne vers le haut</strong> par rapport à la médiane (2nd coefficient d'asymétrie de Pearson =",
    "info-14": "Merci d'inspecter les réponses de l'enquête.",
    "info-15": "Aucune réponse extrême ainsi qu'aucune asymétrie dans les données n'ont été détectés (2nd coefficient d'asymétrie de Pearson =",
    "info-16": "La réponse extrême présentée en rouge est détectée à partir des distances journalières parcourues par individu tous modes de déplacement confondus. Merci d'inspecter les réponses de l'enquête.",
    "info-17": "Une fois le questionnaire cloné, vous pouvez consulter les émissions associées dans les onglets « Les résultats ».",
    "field-1": "Activer",
    "field-2": "Désactiver",
    "field-3": "Statut de l'enquête",
    "field-4": "Actif",
    "field-5": "Inactif",
    "field-6": "Indisponible",
    "field-7": "Nombre de réponses",
    "field-8": "Taux de réponse",
    "field-9": "Réponse(s) extrême(s)",
    "field-10": "Anomalie(s) détectée(s)",
    "field-11": "Réponses au questionnaire",
    "field-12": "Configuration du questionnaire",
    "field-13": "Message à ajouter en en-tête du questionnaire (optionnel)",
    "field-14": "Réponse au questionnaire déplacement domicile-travail",
    "field-15": "Détection d'anomalie",
    "field-16": "Détection de réponses extrêmes",
    "field-17": "Distance en km",
    "field-18": "Distance en log(x+1)",
    "field-19": "Cloné",
    "field-20": "Cloner",
    "field-21": "Décloner",
    "field-22": "Activer"
  },
  "en": {
    "title": "Commuting",
    "save-msg-1": "The message header of the survey has been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "save-msg-2": "The data relating to commuting have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "warning-msg-1": "The number of engineers, technicians, assistant engineers, and research support staff that have answered the survey is greater than the number of engineers, technicians, assistant engineers, and research support staff declared in the laboratory.",
    "warning-msg-2": "The number of PhD students and postdocs that have answered the survey is greater than the number of PhD students and postdocs declared in the laboratory.",
    "warning-msg-3": "The number of researchers and professors that have answered the survey is greater than the number of researchers and professorts declared in the laboratory.",
    "error-msg-1": "Delete",
    "error-msg-2": "Are you sure you want to delete the data relating to commuting?",
    "error-msg-3": "The 2020 survey is not clonable.",
    "error-msg-4": "As the year 2020 is atypical, its survey must be carried out.",
    "error-msg-5": "Survey responses are already saved, cloning is not possible",
    "error-msg-6": "The survey of the GHG inventory of",
    "error-msg-7": "is already a cloned survey",
    "error-msg-8": "No GHG inventory available in",
    "validate-msg-1": "Validation",
    "validate-msg-2": "Outliers have been detected in your data. <br /> Are you sure you want to validate the data without deleting the outliers?",
    "info-1": "Emissions from commuting are estimated through a survey specifically customized for your laboratory. You can: : <ul style='list-style-type:square;margin-left:25px'><li>either send the survey to your colleagues, copy and paste the URL and click on the button <strong>«Activate»</strong>. When you decide to close the survey once and for all, click on the button <strong>«Deactivate»</strong>.</li><li>or clone the responses from the previous year's survey and calculate GHG emissions based on the current year's headcount. Only the previous year's survey can be cloned, except for the 2020 survey due to lockdowns that may have permanently altered staff commuting patterns.</li></ul>",
    "info-3": "In order to get a high response rate, it is important that the survey be sent outside the school holiday periods and away from the summer holidays. We recommend that you send it for the first time in the early morning at the beginning of a given week. Then you send it as a reminder and set the response deadline in the early morning at the beginning of the following week. Eventually, you can send a last reminder at the beginning of the survey closing day.",
    "info-4": "When you send the link of the survey to your colleagues, insist that your colleagues answer only once and for all to the survey. As the survey is anonymous, it would be impossible to identify duplicates.",
    "info-5": " The emissions from commuting are estimated through a survey sent to your colleagues via a web link. As the link is customized for every laboratory, a connection to a database is required. The link is thus unavailable in the unauthenticated version of  <em>GES 1point5</em>.",
    "info-6": "You can though add and make changes to commutes directly in the interface.",
    "info-7": " For the <strong>calculation of 2020 emissions</strong>, the year comprises <strong>27 weeks</strong> of commuting (41 weeks of work  minus 14 lock-down weeks) : the simplified assumption is that, during the lock-downs in France, there was no on-premise call and no leave of the staff members",
    "info-8": "For the <strong>calculation of 2021 emissions</strong>, the year comprises <strong>37 weeks</strong> of commuting (41 weeks of work  minus 4 lock-down weeks) : the simplified assumption is that, during the lock-downs in France, there was no on-premise call and no leave of the staff members",
    "info-9": "The",
    "info-10": "outliers",
    "info-11": "presented in red are detected from the daily distances traveled per person, considering all modes of transportation. Please check the survey responses.",
    "info-12": "Outliers are defined as any value outside the range <em>[q1-3x(q3-q1) ; q3+3x(q3-q1)]</em>, where <em>q1</em> and <em>q3</em> are the first and third quartiles and <em>(q3-q1)</em> the interquartile range.",
    "info-13": "No outlier has been detected. Still, <strong>at least one value pushes the mean upwards</strong> relative to the median (Pearson's second coefficient of skewness =",
    "info-14": "Please check the survey responses.",
    "info-15": "No outlier nor any data asymmetry has been detected (Pearson's second coefficient of skewness =",
    "info-16": "The outlier presented in red is detected from the daily distances traveled per person, considering all modes of transportation. Please check the survey responses.",
    "info-17": "Once you have cloned the questionnaire, you can view the related emissions in the « Results » tabs.",
    "field-1": "Activate",
    "field-2": "Deactivate",
    "field-3": "Survey status",
    "field-4": "Active",
    "field-5": "Inactive",
    "field-6": "Unavailable",
    "field-7": "Response count",
    "field-8": "Response rate",
    "field-9": "Outlier(s)",
    "field-10": "Anomalies detected",
    "field-11": "Responses to the survey",
    "field-12": "Survey setting",
    "field-13": "Add a message header (optional)",
    "field-14": "Response to the commuting survey",
    "field-15": "Anomaly detection",
    "field-16": "Outlier detection",
    "field-17": "Distance in km",
    "field-18": "Distance in log(x+1)",
    "field-19": "Cloned",
    "field-20": "Clone",
    "field-21": "Unclone",
    "field-22": "Activate"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur"/>
    <su-service v-if="isAuthenticated" :icon="'bicycle'">
      <template #title>
        {{ $t('title') }}
      </template>
        <span v-html="$t('info-1')" />
        <br />
        <div class="columns">
          <div class="column is-offset-1 is-10">
            <b-field :type="clonableType">
              <p class="control">
                <b-dropdown
                  :disabled="submitted || surveyActive || isClonedSurvey"
                  v-model="surveyAction"
                  aria-role="list"
                >
                  <template v-if="surveyAction==='activate'" #trigger="{ active }">
                    <b-button
                      :label="$t('field-1')"
                      :type="clonableType"
                      icon-left="link"
                      :icon-right="active ? 'caret-up' : 'caret-down'"
                    />
                  </template>
                  <template v-else #trigger="{ active }">
                    <b-button
                      :label="$t('field-20')"
                      :type="clonableType"
                      icon-left="clone"
                      :icon-right="active ? 'caret-up' : 'caret-down'"
                    />
                  </template>
                  <b-dropdown-item
                    value="activate"
                  >
                    <div class="media">
                      <b-icon class="media-left" icon="link"></b-icon>
                      <div class="media-content">
                        <h3>{{ $t('field-22') }}</h3>
                      </div>
                    </div>
                  </b-dropdown-item>
                  <b-dropdown-item
                    value="clone"
                  >
                    <div class="media">
                      <b-icon class="media-left" icon="clone"></b-icon>
                      <div class="media-content">
                        <h3>{{ $t('field-20') }}</h3>
                      </div>
                    </div>
                  </b-dropdown-item>
                </b-dropdown>
              </p>
              <b-input
                v-if="surveyAction==='activate'"
                expanded
                v-model="link"
                :type="clonableType"
                :readonly="true"
              ></b-input>
              <b-input
                v-else
                :type="clonableType"
                expanded
                :readonly="true"
                :value="cloneText"
              ></b-input>
              <p class="control">
                <b-button
                  v-if="surveyAction==='activate'"
                  :disabled="submitted"
                  class="button"
                  :type="clonableType"
                  @click='activate'
                >
                  <span v-if="!surveyActive">{{ $t('field-1') }}</span>
                  <span v-else>{{ $t('field-2') }}</span>
                </b-button>
                <b-button
                  v-else
                  :disabled="submitted || !isClonable"
                  class="button"
                  :type="clonableType"
                  @click='clone'
                >
                  <span v-if="!isClonedSurvey">{{ $t('field-20') }}</span>
                  <span v-else>{{ $t('field-21') }}</span>
                </b-button>
              </p>
            </b-field>
          </div>
        </div>
        <span v-if="surveyAction==='activate'" v-html="$t('info-3')" />
        <br v-if="surveyAction==='activate'" />
        <br v-if="surveyAction==='activate'" />
        <span v-if="surveyAction==='activate'" v-html="$t('info-4')" />
        <span v-else v-html="$t('info-17')" />
    </su-service>
    <su-service v-else :icon="'bicycle'">
      <template #title>
        {{ $t('title') }}
      </template>
      <span v-html="$t('info-5')"></span>
      <br />
      <br />
      {{ $t('info-6') }}
    </su-service>
    <br />
    <b-notification v-if="GHGIyear===2020" :closable="false">
      <span v-html="$t('info-7')"></span>
    </b-notification>
    <b-notification v-if="GHGIyear===2021" :closable="false">
      <span v-html="$t('info-8')"></span>
    </b-notification>
    <div class="columns">
      <div class="column">
        <b-notification :type="statusNotificationType" :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading">
                {{ $t('field-3') }}
              </p>
              <div class="title is-size-2">
                <p v-if="surveyActive">
                  <i class="sui sui-check-circle" style="padding-right: 10px; font-size: 28px;"></i>
                  <span class="is-size-4">{{ $t('field-4') }}</span>
                </p>
                <p v-else-if="isClonedSurvey">
                  <i class="sui sui-clone" style="padding-right: 10px; font-size: 28px;"></i>
                  <span class="is-size-4">{{ $t('field-19') }}</span>
                </p>
                <p v-else>
                  <i class="sui sui-times-circle" style="padding-right: 10px; font-size: 28px;"></i>
                  <span v-if="isAuthenticated" class="is-size-4">{{ $t('field-5') }}</span>
                  <span v-else class="is-size-4">{{ $t('field-6') }}</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading">
                {{ $t('field-7') }}
              </p>
              <div class="title is-size-2">
                <p>
                  {{ nbDeplacements }}
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading">
                {{ $t('field-8') }}
              </p>
              <div class="title is-size-2">
                <p>
                  {{ answerRate }}
                  <span class="is-size-4">%</span>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div class="column">
        <b-notification :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading">
                {{ $t('field-9') }}
              </p>
              <div class="title is-size-2">
                <p>
                  <span v-if="nbDeplacements < 3">-</span>
                  <a
                    v-else-if="(nbDeplacements - nbValidDeplacements) > 0"
                    @click="displayOutliersModal=true"
                    class="link"
                  >
                    {{ nbDeplacements - nbValidDeplacements }}
                  </a>
                  <a
                    v-else-if="isAsymetric()"
                    @click="displayOutliersModal=true"
                    class="link"
                  >
                    ≥1
                  </a>
                  <a
                    v-else
                    @click="displayOutliersModal=true"
                    class="link"
                  >
                    {{ nbDeplacements - nbValidDeplacements }}
                  </a>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
      <div v-if="warnings.length>0" class="column">
        <b-notification type="is-danger" :closable="false">
          <div class="level-item has-text-centered">
            <div>
              <p class="heading">
                {{ $t('field-10') }}
              </p>
              <div class="title is-size-2">
                <p>
                  <a @click="displayWarnings=true" class="link">{{ warnings.length }}</a>
                </p>
              </div>
            </div>
          </div>
        </b-notification>
      </div>
    </div>

    <br />
    <b-tabs
      :animated="false"
    >
      <b-tab-item icon="table" :label="$t('field-11')">
        <br />
        <commutes-table
          :isEditable="!isAuthenticated"
          @view="displayCommute"
        />
        <br />
        <nav class="level">
          <div class="level-left"></div>
          <div class="level-right">
            <div class="buttons">
              <b-button
                v-if="!isAuthenticated"
                :disabled="submitted"
                class="button"
                icon-left="plus"
                @click="displayAddForm()"
              >
                {{ $t('add') }}
              </b-button>
              <b-button
                v-if="isAuthenticated"
                class="level-item"
                icon-left="download"
                :disabled="nbDeplacements===0"
                @click="exportCommutes(GHGIyear)"
              >
                {{ $t('export') }}
              </b-button>
              <b-button
                class="level-item"
                :icon-left="validSavedIcon"
                :disabled="!module.isModified"
                type="is-primary"
                @click="valider()"
              >
                <span v-if="isAuthenticated">{{ $t('save') }}</span>
                <span v-else>{{ $t('validate') }}</span>
              </b-button>
            </div>
          </div>
        </nav>
      </b-tab-item>
      <b-tab-item
        v-if="isAuthenticated && !isClonedSurvey"
        icon="cogs"
        :label="$t('field-12')"
      >
        <br />
        <b-notification :closable="false">
          <b-field
            :label="$t('field-13')"
          >
            <b-input
              type="textarea"
              :disabled="submitted"
              maxlength="500"
              expanded
              @input="hasChanged=true"
              v-model="surveyMessage"
            ></b-input>
          </b-field>
        </b-notification>
        <nav class="level">
          <div class="level-left"></div>
          <div class="level-right">
            <b-button
              class="level-item"
              icon-left="save"
              :disabled="!hasChanged"
              type="is-primary"
              @click="saveSurveyMessage()"
            >
              <span>{{ $t('save') }}</span>
            </b-button>
          </div>
        </nav>
      </b-tab-item>
    </b-tabs>

    <b-modal
      :active.sync="displayModal"
      has-modal-card
      :can-cancel="['escape', 'x', 'outside']"
    >
      <div class="modal-card" style="width: 1000px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('field-14') }}
          </p>
        </header>
        <section class="modal-card-body">
          <commute-form
            v-if="modeCreation"
            :commute="commute"
            :isSurvey="false"
            :year="GHGIyear"
            v-bind:hasWorkingDay2Changed.sync="hasWorkingDay2Changed"
            :modeEdition="!isAuthenticated"
            @submit="add"
            @close="displayModal=false"
          />
          <survey-summary
            v-else
            :isAdmin="true"
            :commute="commute"
            :year="GHGIyear"
          />
        </section>
      </div>
    </b-modal>

    <b-modal
      :active.sync="displayWarnings"
      has-modal-card
    >
      <div class="modal-card" style="width: 800px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('field-15') }}
          </p>
        </header>
        <section class="modal-card-body">
          <div class="box-blue">
            <ul style="list-style-type:square;margin-left:25px">
              <li v-for="(warning,index) in warnings" :key="index">
                {{ warning }}
              </li>
            </ul>
          </div>
        </section>
      </div>
    </b-modal>

    <b-modal
      :active.sync="displayOutliersModal"
      has-modal-card
    >
      <div class="modal-card" style="width: 800px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('field-16') }}
          </p>
        </header>
        <section class="modal-card-body">
          <b-notification
            v-if="nbDeplacements - nbValidDeplacements > 0"
            :closable="false"
          >
            <span v-if="nbDeplacements - nbValidDeplacements > 1">
              {{ $t('info-9') }} <strong>{{ nbDeplacements - nbValidDeplacements }} {{ $t('info-10') }}</strong>
              {{ $t('info-11') }}
            </span>
            <span v-else>
              {{ $t('info-16') }}
            </span>
            <br />
            <span v-html="$t('info-12')"></span>
          </b-notification>
          <b-notification
            v-else-if="isAsymetric()"
            :closable="false"
          >
            <span v-html="$t('info-13')"></span> {{ asymetricCoefficient }}). {{ $t('info-14') }}
            <br />
            <span v-html="$t('info-12')"></span>
          </b-notification>
          <b-notification
            v-else
            :closable="false"
          >
            {{ $t('info-15') }} {{ asymetricCoefficient }}).
            <br />
            <span v-html="$t('info-12')"></span>
          </b-notification>
          <br />
          <div class="columns">
            <div class="column">
              <outliers-boxplot
                :data="allData"
                :yAxisTitle="$t('field-17')"
              />
            </div>
            <div class="column">
              <outliers-boxplot
                :data="allData"
                :log="true"
                :yAxisTitle="$t('field-18')"
              />
            </div>
          </div>
        </section>
      </div>
    </b-modal>

  </div>
</template>

<script>
import { outliersDetection } from '@/mixins/outliersDetection'
import { commute } from '@/mixins/commute'
import Commute from '@/models/carbon/Commute.js'
import { mapGetters } from 'vuex'

export default {
  name: 'Commutes',
  mixins: [outliersDetection, commute],
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'survey-summary': () => import('@/components/carbon/forms/SurveySummary.vue'),
    'commute-form': () => import('@/components/carbon/forms/CommuteForm.vue'),
    'commutes-table': () => import('@/components/carbon/forms/CommutesTable.vue'),
    'outliers-boxplot': () => import('@/components/carbon/graphics/OutliersBoxPlot.vue')
  },
  data () {
    return {
      displayOutliersModal: false,
      displayWarnings: false,
      allData: [],
      displayModal: false,
      modeCreation: false,
      commute: null,
      aide: null,
      reseting: false,
      dropFile: {},
      enqueteTitre: null,
      warnings: [],
      isLoading: false,
      fileFormatError: false,
      currentHost: null,
      hasChanged: false,
      hasWorkingDay2Changed: false
    }
  },
  watch: {
    commutes: {
      handler () {
        this.checkOutliers()
        this.checkNbAnswers()
      },
      deep: true
    },
    answerRate: function () {
      this.checkNbAnswers()
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    commutes: function () {
      return this.$store.getters['commutes/items']
    },
    actionIcon: function () {
      if (this.surveyAction === 'clone') {
        return 'clone'
      } else {
        return 'link'
      }
    },
    cloneText: function () {
      if (this.GHGIyear === 2021) {
        return this.$t('error-msg-3')
      } else if (this.GHGIyear === 2020) {
        return this.$t('error-msg-4')
      } else {
        if (this.previousGHGIYear) {
          if (this.previousGHGIYear.surveyCloneYear) {
            return this.$t('error-msg-6') + ' ' + this.previousGHGIYear.year + ' ' + this.$t('error-msg-7')
          } else {
            if (this.commutes.length > 0 && !this.previousGHGIYear) {
              return this.$t('error-msg-5')
            } else {
              return this.$t('error-msg-6') + ' ' + this.previousGHGIYear.year
            }
          }
        } else {
          return this.$t('error-msg-8') + ' ' + (this.GHGIyear - 1)
        }
      }
    },
    clonableType: function () {
      if (this.surveyAction === 'clone') {
        if (this.isClonable) {
          return 'is-primary'
        } else {
          return 'is-danger'
        }
      } else {
        return 'is-primary'
      }
    },
    isClonable: function () {
      if (this.GHGIyear === 2021) {
        return false
      } else if (this.GHGIyear === 2020) {
        return false
      } else {
        if (this.previousGHGIYear) {
          if (this.previousGHGIYear.surveyCloneYear) {
            return false
          } else {
            if (this.commutes.length > 0 && !this.previousGHGIYear) {
              return false
            } else {
              return true
            }
          }
        } else {
          return false
        }
      }
    },
    previousGHGIYear: function () {
      let allGHGIYears = this.$store.getters['admin/allGHGI'].filter(obj => obj.year === this.GHGIyear - 1)
      if (allGHGIYears.length > 0) {
        return allGHGIYears[0]
      } else {
        return null
      }
    },
    GHGIyear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    statusNotificationType: function () {
      let type = ''
      if (this.surveyActive) {
        type = 'is-info'
      } else if (this.isClonedSurvey) {
        type = 'is-info'
      }
      return type
    },
    link: function () {
      return 'http://' + this.currentHost + '/commutes-survey/' + this.ghgiUUID
    },
    surveyActive: function () {
      return this.$store.getters['ghgi/item']['surveyActive']
    },
    surveyMessage: {
      get: function () {
        return this.$store.getters['ghgi/item']['surveyMessage']
      },
      set: function (message) {
        this.$store.commit('ghgi/UPDATE_MESSAGE', message)
      }
    },
    surveyAction: {
      get: function () {
        return this.$store.getters['commutes/surveyAction']
      },
      set: function (surveyAction) {
        this.$store.commit('commutes/UPDATE_SURVEY_ACTION', surveyAction)
      }
    },
    ghgiUUID: function () {
      return this.$store.getters['ghgi/item']['uuid']
    },
    nbValidDeplacements: function () {
      return this.commutes.filter(obj => obj.isValid && !obj.deleted).length
    },
    nbDeplacements: function () {
      return this.commutes.filter(obj => !obj.deleted).length
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['commutesSubmitted']
    },
    isClonedSurvey: function () {
      return this.$store.getters['ghgi/isClonedSurvey']
    },
    module: function () {
      return this.$store.getters['commutes/module']
    },
    answerRate: function () {
      let nMember = this.$store.getters['ghgi/nMember']
      return Math.round(this.nbDeplacements / nMember * 100)
    }
  },
  methods: {
    saveSurveyMessage: function () {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('commutes/saveSurveyMessage', this.surveyMessage)
        .then(data => {
          loadingComponent.close()
          this.$buefy.toast.open({
            type: 'is-light',
            message: this.$t('save-msg-1')
          })
          this.hasChanged = false
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    },
    clone: function () {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      let surveyCloneYear = this.GHGIyear - 1
      if (this.isClonedSurvey) {
        surveyCloneYear = null
      }
      this.$store.dispatch('ghgi/cloneSurvey', surveyCloneYear)
        .then(data => {
          if (surveyCloneYear) {
            this.$store.commit('commutes/ISVALID', true)
          } else {
            this.$store.commit('commutes/ISVALID', false)
          }
          loadingComponent.close()
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    },
    activate: function () {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('ghgi/activateGHGISurvey')
        .then(data => {
          loadingComponent.close()
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    },
    openLink: function () {
      window.open(this.link, '_blank')
    },
    checkOutliers: function () {
      this.allData = []
      for (let dpt of this.commutes) {
        if (!dpt.deleted) {
          let dailyDistance = 0
          if (dpt.nWorkingDay > 0) {
            dailyDistance = dpt.getRawWeekDistance() / dpt.nWorkingDay
          }
          this.allData.push({
            'distance': dailyDistance,
            'seqID': dpt.seqID
          })
        }
      }
      this.detectOutliers(this.allData.map(obj => obj.distance))
      for (let dpt of this.commutes) {
        if (!dpt.deleted) {
          let dailyDistance = 0
          if (dpt.nWorkingDay > 0) {
            dailyDistance = dpt.getRawWeekDistance() / dpt.nWorkingDay
          }
          this.$set(
            dpt,
            'isValid',
            !this.isOutlier(dailyDistance)
          )
        }
      }
    },
    checkNbAnswers: function () {
      this.warnings = []
      let nbReponsesITA = this.commutes.filter(obj => obj.position === 'engineer' && !obj.deleted).length
      let nbReponsesDocs = this.commutes.filter(obj => obj.position === 'student' && !obj.deleted).length
      let nbReponsesChercheurs = this.commutes.filter(obj => obj.position === 'researcher' && !obj.deleted).length
      if (nbReponsesITA > this.$store.getters['ghgi/item']['nEngineer']) {
        this.warnings.unshift(this.$t('warning-msg-1'))
      }
      if (nbReponsesDocs > this.$store.getters['ghgi/item']['nStudent']) {
        this.warnings.unshift(this.$t('warning-msg-2'))
      }
      if (nbReponsesChercheurs > this.$store.getters['ghgi/item']['nResearcher'] + this.$store.getters['ghgi/item']['nProfessor']) {
        this.warnings.unshift(this.$t('warning-msg-3'))
      }
    },
    closeModal: function () {
      this.displayModal = false
      this.commute = null
    },
    add: function (commute) {
      this.$store.dispatch('commutes/add', commute)
      this.$store.commit('commutes/ISMODIFIED', true)
      this.closeModal()
    },
    displayAddForm: function () {
      this.modeCreation = true
      this.hasWorkingDay2Changed = false
      let id = this.commutes.length + 1
      this.commute = new Commute(
        'u' + id, null, null, null,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, null,
        false, null, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, null, false
      )
      this.displayModal = true
    },
    displayCommute: function (commute) {
      this.modeCreation = false
      this.commute = commute
      this.displayModal = true
    },
    reset: function () {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('error-msg-1'),
        message: self.$t('error-msg-2'),
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.warnings = []
          self.reseting = true
          self.dropFile = {}
          self.$store.dispatch('commutes/resetState')
          if (self.isAuthenticated) {
            const loadingComponent = self.$buefy.loading.open({
              container: null
            })
            self.$store.dispatch('commutes/save')
              .then(data => {
                loadingComponent.close()
              })
              .catch((erreur) => {
                loadingComponent.close()
                self.$store.commit('commutes/ERREUR', erreur.response.data)
              })
          }
        }
      })
    },
    valider: function () {
      let self = this
      if (this.nbValidDeplacements !== this.nbDeplacements) {
        this.$buefy.dialog.confirm({
          title: self.$t('validate-msg-1'),
          message: self.$t('validate-msg-2'),
          confirmText: self.$t('validate'),
          cancelText: self.$t('cancel'),
          canCancel: ['escape', 'button', 'outside'],
          onConfirm: function () {
            self.subValider()
          }
        })
      } else {
        this.subValider()
      }
    },
    subValider: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('commutes/save')
          .then(data => {
            loadingComponent.close()
            this.dropFile = {}
            this.$store.commit('commutes/ISVALID', true)
            this.$store.commit('commutes/ERREUR', '')
            this.$store.commit('commutes/ISMODIFIED', false)
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg-2')
            })
          })
          .catch((erreur) => {
            loadingComponent.close()
            this.$store.commit('commutes/ISVALID', false)
            this.$store.commit('commutes/ERREUR', erreur.response.data)
          })
      } else {
        this.$store.commit('commutes/ISVALID', true)
        this.$store.commit('commutes/ISMODIFIED', false)
      }
    }
  },
  created: function () {
    this.currentHost = window.location.host
  }
}
</script>

<style scoped>
  .notification.is-info {
    background-color: #3e8ed0 !important;
    color: #fff !important;
  }
  .notification.is-danger p.heading {
    color: #fff !important;
  }
  .notification.is-danger a.link {
    color: #fff !important;
    text-decoration: none !important;
  }
  .notification.is-danger a.link:hover {
    color: #fdbac7 !important;
  }
  .dropdown .dropdown-menu .has-link a.is-active, a.dropdown-item.is-active, button.dropdown-item.is-active {
    background-color: #4680df;
    color: #fff;
  }
</style>
